#' In-line documentation for R.
#'
#' MIIVsem is a package for estimating structural equation models 
#' using model-implied instrumental variables (MIIVs).
#'
#' 
#' @author Zachary Fisher, \cr
#' Ken Bollen, \cr
#' Kathleen Gates, \cr
#' Mikko Rönkkö \cr
#' 
#' Maintainer: Zachary Fisher 
#'
#' @name MIIVsem
#' @docType package
#' @import lavaan Matrix
#' 
#' @seealso See \code{vignette("MIIVsem", package = "MIIVsem")} for an overview
#'   of the package, \code{vignette("miivs", package = "MIIVsem")} for model-
#'   implied instrumental variable search, and \code{vignette("miive", package = "MIIVsem")} 
#'   for estimating models. 
#' @keywords 2SLS, two stage least squares, MIIV, instrument, SEM
NULL
